]> git.saurik.com Git - bison.git/blame - bootstrap
In the grammar file, the first column is 1 not 0 on the first line as
[bison.git] / bootstrap
CommitLineData
01c56de4
AD
1#! /bin/sh
2
1f65350a 3# Bootstrap this package from CVS.
01c56de4 4
b4068c7c 5# Copyright (C) 2003, 2004, 2005, 2006 Free Software Foundation, Inc.
1f65350a
PE
6
7# This program is free software; you can redistribute it and/or modify
8# it under the terms of the GNU General Public License as published by
9# the Free Software Foundation; either version 2, or (at your option)
10# any later version.
11
12# This program is distributed in the hope that it will be useful,
13# but WITHOUT ANY WARRANTY; without even the implied warranty of
14# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15# GNU General Public License for more details.
16
17# You should have received a copy of the GNU General Public License
18# along with this program; if not, write to the Free Software
0fb669f9
PE
19# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
20# 02110-1301, USA.
1f65350a
PE
21
22# Written by Paul Eggert.
23
24package=bison
25
5a2baae7
PE
26# Translation Project URL, for the registry of all projects.
27TP_URL='http://www.iro.umontreal.ca/translation/registry.cgi?domain='
28
a9f027b9
PE
29# Ensure file names are sorted consistently across platforms;
30# e.g., m4/ulonglong_gl.m4 should follow m4/ulonglong.m4.
b5240ba5 31# Also, ensure diagnostics are in English, e.g., "wget --help" below.
a9f027b9
PE
32LC_ALL=C
33export LC_ALL
34
1f65350a
PE
35# Parse options.
36
37for option
38do
39 case $option in
40 --help)
41 echo "$0: usage: $0 [--gnulib-srcdir=DIR] [--cvs-user=USERNAME] [--skip-po]"
42 exit;;
43 --gnulib-srcdir=*)
e23d0dd7 44 GNULIB_SRCDIR=`expr "$option" : '--gnulib-srcdir=\(.*\)'`;;
1f65350a 45 --cvs-user=*)
e23d0dd7 46 CVS_USER=`expr "$option" : '--cvs-user=\(.*\)'`;;
1f65350a
PE
47 --skip-po)
48 SKIP_PO=t;;
49 *)
50 echo >&2 "$0: $option: unknown option"
51 exit 1;;
52 esac
53done
54
55echo "$0: Bootstrapping CVS $package..."
56
e10a80ee
PE
57cleanup_gnulib() {
58 status=$?
59 rm -fr gnulib
60 exit $status
61}
62
1f65350a
PE
63# Get gnulib files.
64
65case ${GNULIB_SRCDIR--} in
66-)
67 if [ ! -d gnulib ]; then
68 echo "$0: getting gnulib files..."
69
26546b42
PE
70 case ${CVS_AUTH-pserver} in
71 pserver)
72 CVS_PREFIX=':pserver:anonymous@';;
1f65350a
PE
73 ssh)
74 CVS_PREFIX="$CVS_USER${CVS_USER+@}";;
75 *)
76 echo "$0: $CVS_AUTH: Unknown CVS access method" >&2
77 exit 1;;
78 esac
79
80 case $CVS_RSH in
81 '') export CVS_RSH=ssh;;
82 esac
83
e10a80ee
PE
84 trap cleanup_gnulib 1 2 13 15
85
26546b42 86 cvs -z3 -q -d ${CVS_PREFIX}cvs.savannah.gnu.org:/cvsroot/gnulib co gnulib ||
e10a80ee 87 cleanup_gnulib
1f65350a 88
e10a80ee 89 trap - 1 2 13 15
1f65350a
PE
90 fi
91 GNULIB_SRCDIR=gnulib
92esac
93
94<$GNULIB_SRCDIR/gnulib-tool || exit
95
96gnulib_modules='
1f65350a
PE
97argmatch
98dirname
99error
42e826a4 100extensions
1f65350a 101getopt
c3d5a4a7 102gettext
1f65350a
PE
103hard-locale
104hash
105malloc
106mbswidth
107obstack
108quote
109quotearg
110stdbool
3ea5f0ec 111stdio-safer
1f65350a 112stpcpy
55f0c7b1
PE
113strerror
114strtoul
b50d2359 115strverscmp
3ea5f0ec 116unistd-safer
fb9c0b33 117unlocked-io
8a6f72f3 118verify
1f65350a 119xalloc
a9f027b9 120xalloc-die
1f65350a
PE
121xstrndup
122'
123
124previous_gnulib_modules=
125while [ "$gnulib_modules" != "$previous_gnulib_modules" ]; do
126 previous_gnulib_modules=$gnulib_modules
127 gnulib_modules=`
128 (echo "$gnulib_modules"
129 for gnulib_module in $gnulib_modules; do
130 $GNULIB_SRCDIR/gnulib-tool --extract-dependencies $gnulib_module
131 done) | sort -u
132 `
133done
134
135gnulib_files=`
136 (for gnulib_module in $gnulib_modules; do
137 $GNULIB_SRCDIR/gnulib-tool --extract-filelist $gnulib_module
138 done) | sort -u
139`
140
141gnulib_dirs=`echo "$gnulib_files" | sed 's,/[^/]*$,,' | sort -u`
142mkdir -p $gnulib_dirs || exit
143
144for gnulib_file in $gnulib_files; do
145 dest=$gnulib_file
146
147 case $gnulib_file in
148 m4/onceonly_2_57.m4) dest=m4/onceonly.m4;;
a9f027b9
PE
149 # These will be overwritten by autopoint, which still uses
150 # old jm_.* macro names, so we have to keep both copies.
151 # m4/gettext.m4 isn't mentioned here, since it's patched below.
152 m4/glibc21.m4 | m4/inttypes_h.m4 | m4/lib-ld.m4 | \
153 m4/lib-prefix.m4 | m4/po.m4 | m4/stdint_h.m4 | m4/uintmax_t.m4 | \
154 m4/ulonglong.m4)
155 dest=`expr $gnulib_file : '\(.*\).m4'`_gl.m4;;
1f65350a
PE
156 esac
157
158 rm -f $dest &&
159 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file" &&
160 cp -p $GNULIB_SRCDIR/$gnulib_file $dest || exit
161done
162
7e7b77c1
PE
163# This suppresses a bogus diagnostic
164# "warning: macro `AM_LANGINFO_CODESET' not found in library".
165echo "$0: patching m4/gettext.m4 so that AM_INTL_SUBDIR is empty ..."
166sed '
167 /^AC_DEFUN(\[AM_INTL_SUBDIR],/,/^]/c\
168 AC_DEFUN([AM_INTL_SUBDIR], [])
169' m4/gettext.m4 >m4/gettext_gl.m4 || exit
170
1f65350a
PE
171
172# Get translations.
173
5a2baae7
PE
174get_translations() {
175 subdir=$1
176 domain=$2
177
178 echo "$0: getting translations into $subdir for $domain..."
179 (cd $subdir && rm -f dummy `ls | sed -n '/\.gmo$/p; /\.po/p'`) &&
180
181 $WGET_COMMAND -O "$subdir/$domain.html" "$TP_URL$domain" &&
182
183 sed -n 's|.*"http://[^"]*/translation/teams/PO/\([^/"]*\)/'"$domain"'-\([^/"]*\)\.[^."]*\.po".*|\1.\2|p' <"$subdir/$domain.html" |
184 sort -k 1,1 -k 2,2n -k2,2 -k3,3n -k3,3 -k4,4n -k4,4 -k5,5n -k5.5 |
185 awk -F. '
186 { if (lang && $1 != lang) print lang, ver }
187 { lang = $1; ver = substr($0, index($0, ".") + 1) }
188 END { if (lang) print lang, ver }
189 ' | awk -v domain="$domain" -v subdir="$subdir" '
190 {
191 lang = $1
192 ver = $2
193 urlfmt = ""
194 printf "$WGET_COMMAND -O %s/%s.po 'http://www.iro.umontreal.ca/translation/teams/PO/%s/%s-%s.%s.po' &&\n", subdir, lang, lang, domain, ver, lang
195 }
196 END { print ":" }
197 ' | sh &&
198 ls "$subdir"/*.po | sed 's|.*/||; s|\.po$||' >"$subdir/LINGUAS" &&
199 rm "$subdir/$domain.html"
200}
201
1f65350a
PE
202case $SKIP_PO in
203'')
b5240ba5
PE
204 case `wget --help` in
205 *'--no-cache'*)
206 no_cache='--no-cache';;
207 *'--cache=on/off'*)
208 no_cache='--cache=off';;
209 *)
210 no_cache='';;
211 esac
212
5a2baae7
PE
213 WGET_COMMAND="wget -nv $no_cache"
214 export WGET_COMMAND
215
216 get_translations po $package || exit
f7ab6a50
PE
217
218 case $package in
219 bison)
5a2baae7 220 get_translations runtime-po $package-runtime || exit
f7ab6a50 221 esac;;
1f65350a
PE
222esac
223
224
225# Generate autoconf and automake snippets.
226
227(echo '# This file is generated automatically by "bootstrap".' &&
228 echo 'AC_DEFUN([GNULIB_AUTOCONF_SNIPPET],[' &&
229 $GNULIB_SRCDIR/gnulib-tool --extract-autoconf-snippet $gnulib_modules &&
230 echo '])'
231) >m4/gnulib.m4 || exit
232
233(echo '# This file is generated automatically by "bootstrap".' &&
47671055
PE
234 $GNULIB_SRCDIR/gnulib-tool --extract-automake-snippet $gnulib_modules |
235 sed 's/^[ ]*AM_CPPFLAGS[ ]*+=/# (commented out by bootstrap) &/'
1f65350a
PE
236) >lib/gnulib.mk || exit
237
238
239# Reconfigure, getting other files.
240
241echo "$0: autoreconf --verbose --install --force ..."
242autoreconf --verbose --install --force || exit
243
e23d0dd7 244
1f65350a 245# We don't need intl, so remove it.
e23d0dd7
PE
246# Remove aclocal.m4 too, so that it gets rebuilt.
247intl_files_to_remove='
248 aclocal.m4
249 intl
250 m4/codeset.m4
a9f027b9 251 m4/gettext.m4
3ea5f0ec 252 m4/glibc2.m4
e23d0dd7
PE
253 m4/glibc21.m4
254 m4/intdiv0.m4
255 m4/intmax.m4
256 m4/inttypes_h.m4
257 m4/inttypes.m4
258 m4/inttypes-pri.m4
259 m4/isc-posix.m4
260 m4/lcmessage.m4
a9f027b9
PE
261 m4/lib-ld.m4
262 m4/lib-prefix.m4
e23d0dd7
PE
263 m4/longdouble.m4
264 m4/longlong.m4
a9f027b9 265 m4/po.m4
e23d0dd7
PE
266 m4/printf-posix.m4
267 m4/signed.m4
268 m4/size_max.m4
269 m4/stdint_h.m4
270 m4/uintmax_t.m4
271 m4/ulonglong.m4
272 m4/wchar_t.m4
273 m4/wint_t.m4
274 m4/xsize.m4
275'
276echo $0: rm -fr $intl_files_to_remove ...
277rm -fr $intl_files_to_remove || exit
278
b4068c7c
PE
279# Undo changes to gnulib files that autoreconf made.
280for gnulib_file in $gnulib_files; do
281 test ! -f $gnulib_file || cmp -s $gnulib_file $GNULIB_SRCDIR/$gnulib_file || {
282 rm -f $gnulib_file &&
283 echo "$0: Copying file $GNULIB_SRCDIR/$gnulib_file again" &&
284 cp -p $GNULIB_SRCDIR/$gnulib_file $gnulib_file || exit
285 }
286done
287
1f65350a
PE
288# Put bug-reporting address into po/Makevars.
289echo "$0: sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars ..."
290sed '/^MSGID_BUGS_ADDRESS *=/s/=.*/= bug-bison@gnu.org/' po/Makevars.template >po/Makevars
291
f7ab6a50
PE
292# Likewise for runtime-po/Makevars, except also change a few other parameters.
293sed '
294 s/^\(DOMAIN\) *=.*/\1 = bison-runtime/
295 s/^\(subdir\) *=.*/\1 = runtime-po/
30757c8c 296 s/^\(XGETTEXT_OPTIONS\) *=.*/\1 = --keyword=YY_/
f7ab6a50
PE
297' <po/Makevars >runtime-po/Makevars
298
299# Copy identical files from po to runtime-po.
30757c8c 300(cd po && cp -p Makefile.in.in *-quot *.header *.sed *.sin ../runtime-po)
1f65350a
PE
301
302# if src/parse-gram.[ch] are out of date, rebuild them.
b9c85d5c 303parse_gram_y=`find src/parse-gram.y \
1f65350a 304 '(' -newer src/parse-gram.c -o -newer src/parse-gram.h ')' \
b9c85d5c 305 -print` || exit
1f65350a
PE
306case $parse_gram_y in
307?*)
308 echo "$0: warning: bootstrapping with old src/parse-gram.[ch] files."
309
310 echo "$0: touch -c src/parse-gram.[ch] ... "
311 touch -c src/parse-gram.[ch] || exit
312
313 echo "$0: ./configure --disable-nls ..."
314 ./configure --disable-nls || exit
315
316 echo "$0: (cd lib && make) ..."
317 (cd lib && make) || exit
318
319 echo "$0: (cd src && make) ..."
320 (cd src && make) || exit
321
322 echo "$0: rm -f src/parse-gram.c src/parse-gram.h ..."
323 rm -f src/parse-gram.c src/parse-gram.h || exit
324
325 echo "$0: (cd src && make parse-gram.c parse-gram.h) ..."
326 (cd src && make parse-gram.c parse-gram.h) || exit
327
328 echo "$0: make distclean ..."
329 make distclean || exit;;
330esac
331
332echo "$0: done. Now you can run './configure'."